import { J as Json, O as ObjectStorage, L as LogHandlerOptions, cV as LogMessage, a as LogHandler } from './uuid-7fe532eb.js';
export { dv as ArgumentsType, cn as AsyncMutex, cI as AsyncReturnType, Y as BinInput, d as CRYPTO_DEFAULT_ALG, e as CRYPTO_DEFAULT_DERIVE_ALG, f as CRYPTO_DEFAULT_DERIVE_ITERATIONS, C as CRYPTO_DEFAULT_HASH_ALG, d3 as Channel, d2 as ChannelMessageEvent, dh as CryptoEncoder, av as DAY_MS, aS as Day, ax as DayInput, aR as DayInputLegacy, aw as DayValue, aY as DecimalInput, aX as DecimalValue, d9 as DefaultListener, cd as Disposable, cc as Disposer, cb as DisposerFunction, da as Emitter, d7 as EmitterAllHandler, d6 as EmitterHandler, de as Encoder, J as Json, dg as JsonEncoder, d8 as ListenerSignature, d4 as LocalChannel, a as LogHandler, L as LogHandlerOptions, cS as LogLevel, cT as LogLevelAlias, cU as LogLevelAliasKey, b as LogLevelAliasType, cV as LogMessage, cR as Logger, cY as LoggerConsoleHandler, cX as LoggerContext, cW as LoggerContextInterface, c as LoggerInterface, d1 as LoggerMemoryHandler, dR as MemStorage, dQ as MemStorageOptions, dk as Message, di as MessageAction, dp as MessageDefinitions, dq as MessageHub, dj as MessageResult, dm as MessagesDefaultMethods, dn as MessagesMethods, dl as MessagesOptions, cm as Mutex, dV as NestedArray, df as NoopEncoder, O as ObjectStorage, cw as Pool, cs as PoolTask, cu as PoolTaskEvents, cq as PoolTaskFn, ct as PoolTaskIdConflictResolution, cr as PoolTaskState, b6 as Primitive, dt as PubSub, dy as RPCFn, dx as RPCOptions, dz as RPCReturn, ar as RenderMessagesOptions, dw as ReturnType, bF as RoundingMode, cL as SerialQueue, bQ as SortableItem, cK as TaskEvents, cJ as TaskFn, ab as Uint8ArrayToHexDump, aa as Uint8ArrayToJson, a0 as Uint8ArrayToString, ci as UseDefer, cf as UseDispose, ca as XRX, Z as _decodeUtf8Polyfill, _ as _encodeUtf8Polyfill, I as arrayAvg, K as arrayBatches, w as arrayEmptyInPlace, u as arrayFilterInPlace, o as arrayFlatten, p as arrayIntersection, z as arrayIsEqual, F as arrayMax, G as arrayMin, m as arrayMinus, E as arrayRandomElement, s as arrayRemoveElement, t as arraySetElement, B as arrayShuffle, D as arrayShuffleForce, A as arrayShuffleInPlace, x as arraySorted, y as arraySortedNumbers, H as arraySum, q as arraySymmetricDifference, v as arrayToggleInPlace, n as arrayUnion, l as arrayUnique, bs as avg, bq as between, c4 as cloneJsonObject, c3 as cloneObject, bB as cmp, bA as composeOrderby, M as createArray, d5 as createLocalChannelPair, cx as createPromise, dr as createPromiseProxy, k as csv, aW as dateStringToDays, aV as day, aA as dayDay, aQ as dayDiff, aE as dayFromAny, aG as dayFromDate, aH as dayFromDateGMT, aL as dayFromParts, aM as dayFromString, aJ as dayFromTimestamp, aD as dayFromToday, az as dayMonth, aN as dayMonthStart, aP as dayOffset, aC as dayToDate, aF as dayToDateGMT, aB as dayToParts, aK as dayToString, aI as dayToTimestamp, ay as dayYear, aO as dayYearStart, cN as debounce, aZ as decimal, b0 as decimalCentsPart, a_ as decimalFromCents, a$ as decimalToCents, S as decodeBase16, P as decodeBase32, U as decodeBase58, W as decodeBase62, j as decrypt, b1 as deepEqual, b3 as deepMerge, b2 as deepStripUndefinedInPlace, h as deriveKeyPbkdf2, dM as detect, g as digest, c2 as empty, R as encodeBase16, N as encodeBase32, T as encodeBase58, V as encodeBase62, bY as encodeQuery, i as encrypt, bS as endSortWeight, b_ as ensureKey, b$ as ensureKeyAsync, a8 as equalBinary, b4 as escapeHTML, bE as escapeRegExp, X as estimateSizeForBase, dD as fetchBasic, dE as fetchJson, dI as fetchOptionsBasicAuth, dG as fetchOptionsFormURLEncoded, dH as fetchOptionsJson, dF as fetchText, au as fixBrokenUth8String, aT as forEachDay, c7 as forTimes, as as formatMessages, dT as formatMilliseconds, a7 as fromBase64, af as fromCamelCase, a4 as fromHex, dL as getGlobal, cO as getGlobalContext, db as getGlobalEmitter, cQ as getGlobalLogger, cZ as getNamespaceFilterString, dK as getNavigator, bl as getSecureRandom, bm as getSecureRandomIfPossible, dS as getTimestamp, dJ as getWindow, dB as httpMethod, cz as immediate, b9 as isArray, bf as isBoolean, dN as isBrowser, bH as isEven, bG as isHalf, bd as isInteger, cP as isLocalHost, bg as isNullOrUndefined, bc as isNumber, b7 as isObject, bu as isPrime, bt as isPrimeRX, b8 as isPrimitive, cG as isPromise, ba as isRecord, be as isSafeInteger, bb as isString, cD as isTimeout, bh as isUint8Array, a2 as joinToUint8Array, bk as jsonStringify, bj as jsonStringifySafe, bi as jsonStringifySorted, a9 as jsonToUint8Array, c1 as last, dd as lazyListener, bW as linkifyPlainText, c5 as memoize, c6 as memoizeAsync, dc as messages, bT as moveSortWeight, by as objectIsEmpty, bw as objectMap, bx as objectMergeDisposable, dC as parseBasicAuth, dU as parseDate, c$ as parseLogLevel, bz as parseOrderby, bZ as parseQuery, dO as platform, cH as promisify, ef as qid, bn as randomBoolean, bp as randomFloat, bo as randomInt, r as randomUint8Array, c9 as regExpEscape, c8 as regExpString, at as renderMessages, bJ as roundDown, bM as roundHalfAwayFromZero, bN as roundHalfDown, bO as roundHalfEven, bL as roundHalfOdd, bP as roundHalfTowardsZero, bK as roundHalfUp, bI as roundUp, bv as seededRandom, e9 as setUuidDefaultEncoding, c0 as size, cy as sleep, bU as sortedItems, bC as sortedOrderby, bR as startSortWeight, ag as stringToBoolean, ai as stringToFloat, ah as stringToInteger, $ as stringToUInt8Array, e5 as suid, e4 as suidBytes, e7 as suidBytesDate, e6 as suidDate, br as sum, cM as throttle, cB as timeout, cA as timeoutReached, cC as timoutError, a5 as toBase64, a6 as toBase64Url, aq as toBool, ac as toCamelCase, ad as toCapitalize, ae as toCapitalizeWords, an as toFloat, a3 as toHex, bX as toHumanReadableUrl, ao as toInt, ap as toString, a1 as toUint8Array, bD as toValidFilename, aU as today, cE as tryTimeout, ee as uname, b5 as unescapeHTML, cp as useAsyncMutex, Q as useBase, ch as useDefer, ce as useDispose, cg as useDisposer, cl as useEventListener, dP as useExitHandler, ck as useInterval, d0 as useLevelFilter, ds as useMessageHub, co as useMutex, c_ as useNamespaceFilter, cv as usePool, du as usePubSub, dA as useRPC, bV as useSorted, cj as useTimeout, ea as uuid, e8 as uuid32bit, d_ as uuidB32, dX as uuidB62, dW as uuidBytes, eb as uuidDecode, e0 as uuidDecodeB32, dZ as uuidDecodeB62, e3 as uuidDecodeV4, ec as uuidEncode, d$ as uuidEncodeB32, dY as uuidEncodeB62, e2 as uuidEncodeV4, ed as uuidIsValid, e1 as uuidv4, aj as valueToBoolean, al as valueToFloat, ak as valueToInteger, am as valueToString, cF as waitOn } from './uuid-7fe532eb.js';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

interface csvOptions {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
}
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): any[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

export { FileStorage, FileStorageOptions, LoggerFileHandler, LoggerNodeHandler, colorString, colorStringList, ensureFolder, exists, getEnvVariableRelaxed, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, stringToPath, toHumanReadableFilePath, toPath, valueToPath, writeText };
